//===============================================================
// Lawson Labs, Inc.
// 3217 Phoenixville Pike
// Malvern, PA  19355
// 800 321-5355 or 610-725-8800
//-----------------------------
// Programmer: Tim Van Dusen
// Last modified: 4-30-01
// Name: VC5_APP.h
//===============================================================


#include <windows.h>
#include <winnt.h>
#include <wtypes.h>


//6-18-01
BYTE bScanTypes[64];




//***************************************************************
//*-------- C  O  N  S  T  A  N  T  S ---------------------------\
//****************************************************************\
//================================================================*\
//=================================================================*>
//================================================================*/
/*****************************************************************/
// Certain things aren't applicable while developing in house. 
// For example allowed device ID's in-house are 1-100, while once distributed, valid
// ID's will be 101-32767 
#define IN_HOUSE

#define DO_READ 1
#define DO_WRITE 0
#define USER_INPUT_REQUIRED		TRUE
#define NO_USER_INPUT_REQUIRED	FALSE

#define CMND_SIGN_ON					0x0
#define CMND_RESET					0x01
#define CMND_DIG_OUT					0x02
#define CMND_CHAN_CHG				0x04
#define CMND_GET_CONVERSION		0x81
#define CMND_SET_MODE				0x84
#define CMND_SYS_CAL					0x85
#define CMND_CHECKSUM_SCAN			0x8D
#define NO_ARG							0x0
#define SHOW_LISTS					TRUE
#define DONT_SHOW_LISTS				FALSE



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-------- M  A  C  R  O  S -------------------------------------






//***************************************************************







//-------- M  A  C  R  O  S -------------------------------------






//***************************************************************







//-------- M  A  C  R  O  S -------------------------------------






//***************************************************************







//-------- M  A  C  R  O  S -------------------------------------






//***************************************************************
//*-------- M  A  C  R  O  S ------------------------------------\
//****************************************************************\
//================================================================*\
//=================================================================*>
//================================================================*/
/*****************************************************************/
// Variables used in macros (and elsewhere in code).
//3-21-01 HANDLE	hOutCon, hInCon;
HWND	hOutCon, hInCon;
COORD	pos, dwCursorPosition;
CONSOLE_CURSOR_INFO	ConsoleCursorInfo;
CONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo;
DWORD	lpNumberOfCharsWritten;

#define gotoxy(x, y) pos.X = x; pos.Y = y - 1;	\
SetConsoleCursorPosition(hOutCon, pos);

#define clrscr() pos.X = 0; pos.Y = 0;		\
FillConsoleOutputCharacter(hOutCon, ' ',	\
80*25, pos, &lpNumberOfCharsWritten);

char ConBuff[512];
char* pConBuff = ConBuff;

#define WRITE_CON \
WriteConsole(hOutCon, pConBuff, strlen(ConBuff), \
&lpNumberOfCharsWritten, NULL);



#define CLEAR_MSG_LINE \
gotoxy(0,24); sprintf(ConBuff, "                                                                             "); WRITE_CON  \
gotoxy(0,24); 

#define LINE_CLEAR(x) \
gotoxy(0,x); sprintf(ConBuff,"                                                                                "); WRITE_CON



//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************







//-------- V  A  R  I  A  B  L  E  S ----------------------------







//***************************************************************







//-------- V  A  R  I  A  B  L  E  S ----------------------------







//***************************************************************







//-------- V  A  R  I  A  B  L  E  S ----------------------------







//***************************************************************







//-------- V  A  R  I  A  B  L  E  S ----------------------------







//***************************************************************







//-------- V  A  R  I  A  B  L  E  S ----------------------------







//***************************************************************
//*-------- V  A  R  I  A  B  L  E  S ---------------------------\
//****************************************************************\
//================================================================*\
//==== D E V I C E    R E L A T E D ===============================*>
//================================================================*/
/*****************************************************************/
BYTE bNumDevices						= 0;
BYTE bNumDevicesTemp					= 0;
USHORT usCurrentDevice				= 0;

USHORT usLLABS_DeviceIDList		[64];
USHORT* pusLLABS_DeviceIDList;
BYTE bUnusedValues					[64];
BYTE* pbUnusedVar;

BOOLEAN fNeedToFreeListOnExit		= FALSE;

BYTE bActiveDevAsIndex				= 0;
USHORT usActiveDevID					= 0;

BOOLEAN fInstInitReserved			= DONT_SHOW_LISTS;

#define RETRY_MAX 3

//****************************************************************\
//================================================================*\
//==== D E V I C E    R E A D / W R I T E =========================*>
//================================================================*/
/*****************************************************************/
BYTE bHostClientDataBuf_WRITE		[8];
BYTE bHostClientDataBuf_READ		[32];
UINT NumBytesToReadWrite;


//****************************************************************\
//================================================================*\
//==== D L L   T O   A P P   M E S S A G I N G  ===================*>
//================================================================*/
/*****************************************************************/
char szMsgDialog[512];
char caMsgBuff[1024] = "";
BOOLEAN fMsgPending = FALSE;
char* pMsgDLL = "";
BOOLEAN fMsgBuffFull = FALSE;


//****************************************************************\
//================================================================*\
//==== C O N F I G U R A T I O N  =================================*>
//================================================================*/
/*****************************************************************/
typedef struct _M301_CONFIG_DATA{
    USHORT usDevID;
	 BYTE bChan;
    DOUBLE dblRate;
    DOUBLE dblActualRate;	
}M301_CONFIG_DATA, *PM301_CONFIG_DATA;
PM301_CONFIG_DATA pM301ConfigData;
M301_CONFIG_DATA aM301ConfigData		[64];

char    M301FileName						[64];
HANDLE	hM301Config;
FILE    *fpCfgIn							= NULL;
FILE    *fpCfgOut							= NULL;

BOOLEAN	fValidConfigExists			= FALSE;


//****************************************************************\
//================================================================*\
//==== S C A N    R E L A T E D  ==================================*>
//================================================================*/
/*****************************************************************/
char    szScanLogFilename				[64];
HANDLE	hM301LogScan;
BOOLEAN	fLogScansToFile				= FALSE;
FILE    *fpLogScanIn						= NULL;
FILE    *fpLogScanOut					= NULL;
USHORT usActiveScanDevID				= 0;
USHORT usActiveScanDevIndex			= 0;


typedef struct _SCAN_OBJECT {
	#define SINGLE_CHAN							1
	#define TWO_CHAN								2
	BYTE				SO_bScanType;
	DOUBLE			SO_dblRate;

	//4-30-01 changed name of following two variables 
	//  here and in C file
	UINT				SO_uiTotalPointsReadByDrvr;
	UINT				SO_uiPointsInBuffer;

	#define SCAN_RUNNING 						0x01
	#define SCAN_DATA_REQUEST_SUCCEEDED		0x02
	#define SCAN_ENDING 							0x04
	#define SCAN_HALTED 							0x08
	#define SCAN_CHECKSUM_ERROR				0x10
	#define SCAN_VOLTAGE_BUFFER_WRAP			0x20
	#define SCAN_MICRO_CODE_BUFF_WRAP		0x40
	#define SCAN_DEVICE_IO_ERROR				0x80
	#define SCAN_DEVICE_REMOVED				0x100
	#define SCAN_DEVICE_NOT_FOUND				0x200
	UINT				SO_uiStatus;

	UINT				SO_uiSizeVoltageArray;
	UINT				SO_uiCurHead;
	UINT				SO_uiCurTail;
	BYTE				SO_bDigitalInput;
	BYTE				SO_bChecksum;
	// App sets this if device unplugged (not used in this sample code)
	BYTE				SO_DeviceDisconnect; 

	clock_t			SO_ScanStartTime;
	clock_t			SO_ScanEndTime;
 
	BYTE				SO_bScanArg;
} SCAN_OBJECT, *PSCAN_OBJECT;
PSCAN_OBJECT apScanObject[64];


#define NOT_SCANNING 							0x0
#define SCANNING 									0x01
BYTE bDevScanning[64];


//****************************************************************\
//================================================================*\
//==== M I S C E L L A N E O U S  =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN	fInitialized					= FALSE;
BOOLEAN	fInitialized_ONCE				= FALSE;	

//HANDLE	hAppWindow, hLibM301CPP, hLibUSER32, hLibSETUPAPI;
HWND	hAppWindow;
HMODULE hLibLL_USB = NULL, hUnused = NULL;
BOOLEAN ResetDevice();
//---------

BYTE bLastDigin;
SHORT sDebugLevel = 0;

HWND hMainWinDlg;

	
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************






//-------- L O C A L    F U N C T I O N S -----------------------






//***************************************************************






//-------- L O C A L    F U N C T I O N S -----------------------







//***************************************************************






//-------- L O C A L    F U N C T I O N S -----------------------







//***************************************************************






//-------- L O C A L    F U N C T I O N S -----------------------







//***************************************************************






//-------- L O C A L    F U N C T I O N S -----------------------







//***************************************************************
//*-------- L O C A L    F U N C T I O N S ----------------------\
//****************************************************************\
//================================================================*\
//==== S C R E E N    M E N U S ===================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN PrintMainMenuScreen(void);
BOOLEAN UserInputMenu_FUNCTIONS(void);
BOOLEAN PrintUtilityMenuScreen(void);
BOOLEAN PrintScanMenuScreen(void);
BOOLEAN UserInputMenu_MAIN(void);
BOOLEAN PrintFunctionMenuScreen(void);
BOOLEAN UserInputMenu_UTILITY(void);
BOOLEAN UserInputMenu_SCAN(void);


//****************************************************************\
//================================================================*\
//==== C O N S O L E   A N D  C U R S O R   H A N D L I N G =======*>
//================================================================*/
/*****************************************************************/
BOOLEAN SetupConsole(void);
VOID SetWin32CursorOn(void);
VOID SetWin32CursorOff(void);


//****************************************************************\
//================================================================*\
//==== L I B R A R Y    H A N D L I N G ===========================*>
//================================================================*/
/*****************************************************************/
BOOLEAN LoadLibraries(void);
BOOLEAN CheckLibFuncs(void);


//****************************************************************\
//================================================================*\
//==== C O N F I G U R A T I O N ==================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN ReadCfg(void);
BOOLEAN GetFileString(char* szFileLine);


//****************************************************************\
//================================================================*\
//==== I N I T I A L I Z A T I O N  ===============================*>
//================================================================*/
/*****************************************************************/
BOOLEAN InitVars(void);
BOOLEAN Initialize(void);
BOOLEAN SendSignon(USHORT usDevID);
BOOLEAN PrintDevicesAvailable(void);
BOOLEAN SendResetCmnd(USHORT usDevID);


//****************************************************************\
//================================================================*\
//==== R A T E    H A N D L I N G  ================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN CalcRateCodes(BYTE* bLow, BYTE* bMid, BYTE* bHigh, USHORT usDevID);
BOOLEAN SendRate(USHORT usDevID);
BOOLEAN SetRate(USHORT usDevID);


//****************************************************************\
//================================================================*\
//==== I / O    F U N C T I O N S =================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN GetOneConversion(USHORT usDevID);
BOOLEAN DigitalOutput(USHORT usDevID);
BOOLEAN GetUserInputForDigOut(BYTE* bDigOutVal);
BOOLEAN GetUserInputForChanChange(BYTE* bChan);
BOOLEAN ChanChange(USHORT usDevID, BYTE bChan, BOOLEAN fNeedUserInput);


//****************************************************************\
//================================================================*\
//==== S  C  A  N  N  I  N  G =====================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN AllocScanMem(USHORT usDevID);
BOOLEAN ConfigureScan(void);
BOOLEAN StartScan(USHORT usDevID);
BOOLEAN ReadScanData(USHORT usDevID);
BOOLEAN EndScan(USHORT usDevID);


//****************************************************************\
//================================================================*\
//==== M I S C E L L A N E O U S ==================================*>
//================================================================*/
/*****************************************************************/
BOOLEAN CurDevIDChange(void);
BOOLEAN FreeDeviceFromList(void);
BOOLEAN CleanupBeforeExit(void);

BOOLEAN DisplayDigin(BYTE bLastDigin);
BOOLEAN DispDLLMsg(void);

BOOLEAN ReInitializeDevice(); //6-8-00
BOOLEAN SystemCalibration(void);
BOOLEAN VerifyDevIDList(BYTE* bTotDevCnt, BOOLEAN fShowLists);

BOOLEAN GetVersionInfo(void);
BOOLEAN MakeDialog(void);
BOOL CALLBACK DLG_DlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOLEAN TempFunc(void);

//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
//***************************************************************






//-------- E X P O R T E D    F U N C T I O N S -----------------






//***************************************************************






//-------- E X P O R T E D    F U N C T I O N S -----------------






//***************************************************************






//-------- E X P O R T E D    F U N C T I O N S -----------------






//***************************************************************






//-------- E X P O R T E D    F U N C T I O N S -----------------






//***************************************************************






//-------- E X P O R T E D    F U N C T I O N S -----------------





//***************************************************************
//*-------- E X P O R T E D    F U N C T I O N S ----------------\
//****************************************************************\
//================================================================*\
//=================================================================*>
//================================================================*/
/*****************************************************************/
// NOTE TO PROGRAMMER: See DLL Function call explanations 
//   in FuncDesc.doc. Can be viewed with Windows WordPad.
//----------\
//----------->
//----------/
typedef BOOLEAN(*P_DLL_INIT)
					(HWND _hAppMainWin, HMODULE hUnused, HMODULE hUnused2,
					SHORT sDebugLevel, BYTE* bNumDevicesShared, BYTE *pbUnusedVar,
					USHORT *usLLABS_DeviceIDList);
P_DLL_INIT pDLL_Init = NULL;
//----------\
//----------->
//----------/	
typedef BOOLEAN(*P_DLL_GET_DEVICE_ID_LIST)(void);
P_DLL_GET_DEVICE_ID_LIST pDLL_GetDeviceIDList = NULL;
//----------\
//----------->
//----------/
#define fDO_DISP_VER		TRUE
#define fDONT_DISP_VER	FALSE	

typedef BOOLEAN(*P_DLL_GET_VERSION_INFO)(USHORT usDevID, BOOLEAN fDisplayVersion, 
						USHORT* usDevVersion, char* cpDLLVersion, char* cpDrvrVersion);
P_DLL_GET_VERSION_INFO pDLL_GetVersionInfo = NULL;
//----------\
//----------->
//----------/	
typedef BOOLEAN(*P_DLL_RESET_DEVICE)(USHORT usDevID, BYTE bReserved);
P_DLL_RESET_DEVICE pDLL_ResetDevice = NULL;
//----------\
//----------->
//----------/	
// NOTE: See FuncDesc.doc for more information regarding this function.
typedef BOOLEAN(*P_DLL_INSTANCE_INIT_DEVICE_LIST)(BOOLEAN fShowLists);
P_DLL_INSTANCE_INIT_DEVICE_LIST pDLL_InstanceInitDeviceList = NULL;
//----------\
//----------->
//----------/
// NOTE: See FuncDesc.doc for more information regarding this function.
#define FREE_ANY_DEV TRUE
#define FREE_ONLY_APP_OWNED_DEVICES FALSE
typedef BOOLEAN(*P_DLL_RELEASE_DEVICE_FROM_IDLIST)
		(USHORT* usLLABS_DeviceIDToRelease, BOOLEAN fAnyHandle);
P_DLL_RELEASE_DEVICE_FROM_IDLIST pDLL_ReleaseDeviceFromIDList = NULL;
//----------\
//----------->
//----------/
//typedef BOOLEAN(*P_DLL_SET_RATE)(USHORT usDevID, DOUBLE dblRate);
//P_DLL_SET_RATE  pDLL_SetRate = NULL;
typedef BOOLEAN(*P_DLL_SET_RATE)(USHORT usDevID, DOUBLE dblRate);
P_DLL_SET_RATE  pDLL_SetRate = NULL;
//----------\
//----------->
//----------/
typedef BOOLEAN (*P_DLL_READ_WRITE_ONE_DEVICE)(BOOLEAN fReadWrite, 
        BYTE* pDynamicArray, USHORT usDevID, UINT* pNumBytesToRead, 
		  BYTE* pbDigIn, UINT ulTimeOut);
P_DLL_READ_WRITE_ONE_DEVICE pDLL_ReadWriteOneDevice = NULL;
//----------\
//----------->
//----------/
typedef BOOLEAN (*P_DLL_START_SCAN)(USHORT usDevID, 
						PSCAN_OBJECT pScanObj, BYTE bStartMode);
P_DLL_START_SCAN pDLL_StartScan = NULL;
//----------\
//----------->
//----------/
typedef BOOLEAN (*P_DLL_READ_SCAN_DATA)(USHORT usDevID, UINT* DynaVoltageBuff, 
							USHORT numPointsToRead, PSCAN_OBJECT pScanObj);
P_DLL_READ_SCAN_DATA pDLL_ReadScanData = NULL;
//----------\
//----------->
//----------/
typedef BOOLEAN (*P_DLL_END_SCAN)(USHORT usDevID, BOOLEAN fReserved, 
					 UINT uiReserved, BYTE reserved);
P_DLL_END_SCAN pDLL_EndScan = NULL;


 
